"use strict";

ui.App.Init = {
    standbyCallback: function (event, isServiceListUpdatedInStandBy) {
        console.log('STANDBY CALLBACK EVENT = ' + event);
        switch (parseInt(event, 10)) {
            case PluginInterface.Setup.eSmEvents.IMMINENT_SLEEP:
                UIMiniFramework.Modules.PermanentInformations.add(
                    UIMiniFramework.Translations.popups.boxWillEnterIntoStandby[UIMiniFramework.Globals.language],
                    null,
                    false,
                    false,
                    'standbySleep',
                    UIMiniFramework.Translations.sleepTimer[UIMiniFramework.Globals.language]
                );
                break;
            case PluginInterface.Setup.eSmEvents.IMMINENT_NSPD:
                UIMiniFramework.Modules.PermanentInformationstions.add(
                    UIMiniFramework.Translations.popups.pleaseCheckTheAerialConnection[UIMiniFramework.Globals.language],
                    null,
                    false,
                    false,
                    'standbyNspd',
                    UIMiniFramework.Translations.noSignalTimer[UIMiniFramework.Globals.language]
                );
                break;
            case PluginInterface.Setup.eSmEvents.IMMINENT_APD:
                UIMiniFramework.Modules.Confirmations.add(
                    UIMiniFramework.Translations.popups.noUserResponseForLongTime[UIMiniFramework.Globals.language],
                    [],
                    null,
                    null,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    UIMiniFramework.Translations.apdTimer[UIMiniFramework.Globals.language],
                    null,
                    'standbyApd',
                    'standbyApd'
                );
                break;
            case PluginInterface.Setup.eSmEvents.TRANSITION_RUNNING: // 0
                UIMiniFramework.Globals.isStandby = false;
                UIMiniFramework.Tools.toggleStandbyOverlay(false);
                UIMiniFramework.Globals.isServiceListUpdatedInStandby = typeof isServiceListUpdatedInStandBy == 'undefined' ? false : (parseInt(isServiceListUpdatedInStandBy, 10) == 1 ? true : false);
                UIMiniFramework.Modules.VolumeBar.isVolumeBarInitialized = false;
                UIMiniFramework.Globals.isStandbyTriggered = false;
                UIMiniFramework.Globals.service.isZapped = false;
                PluginInterface.Cak.fSetCallbacks(
                    ui.App.Callbacks.cakCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.cakScPinCallback.bind(ui.App.Callbacks)
                );
                PluginInterface.ChannelInstallation.fSetCallbacks(
                    ui.App.Callbacks.scanStatusCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.fetchTranspondersCallback.bind(ui.App.Callbacks)
                );
                PluginInterface.Epg.fSetCallbacks(
                    ui.App.Callbacks.presentFollowingUpdateCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.refreshEpgItems.bind(ui.App.Callbacks)
                );
                PluginInterface.Hbbtv.fSetCallbacks(null);
                PluginInterface.MediaBrowsing.fSetCallbacks(
                    ui.App.Callbacks.multimediaBrowsingCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.dmrCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.networkStatusCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.deviceNotification.bind(ui.App.Callbacks),
                    ui.App.Callbacks.deviceFormatNotification.bind(ui.App.Callbacks),
                    ui.App.Callbacks.deviceMountNotification.bind(ui.App.Callbacks),
                    ui.App.Callbacks.deviceBenchmarkNotification.bind(ui.App.Callbacks)
                );
                PluginInterface.MediaPlayback.fSetCallbacks(ui.App.Callbacks.mediaPlayerCallback.bind(ui.App.Callbacks));
                PluginInterface.ParentalControl.fSetCallbacks(
                    ui.App.Callbacks.pinEntryCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.pinExitCallback.bind(ui.App.Callbacks)
                );
                PluginInterface.Pvr.fSetCallbacks(
                    ui.App.Callbacks.timeshiftCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.pvrBrowsingCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.pvrCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.pvrPlayerCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.pvrScheduledRecordingCallback.bind(ui.App.Callbacks)
                );
                PluginInterface.Reminder.fSetCallbacks(ui.App.Callbacks.reminderCallback.bind(ui.App.Callbacks));
                PluginInterface.ServiceZapper.fSetCallbacks(
                    ui.App.Callbacks.zapperCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.zapperErrorCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.fastZapperCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.serviceListUpdateCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.routeManagerCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.recordingZappCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.digitZapNotificationCallback.bind(ui.App.Callbacks)
                );
                PluginInterface.Setup.fSetCallbacks(
                    ui.App.Callbacks.stateChangeCallback.bind(ui.App.Callbacks),
                    ui.App.Callbacks.update.callback.bind(ui.App.Callbacks.update),
                    ui.App.Callbacks.languageCallback.bind(ui.App.Callbacks)
                );
                PluginInterface.SignalStatus.fSetCallbacks(ui.App.Callbacks.signalStatusCallback.bind(ui.App.Callbacks));
                PluginInterface.StreamComponents.fSetCallbacks(null, null, ui.App.Callbacks.streamComponentNotification.bind(ui.App.Callbacks));

                //called after all callbacks are set
                PluginInterface.Setup.fRemoveLoadingScreen();

                // Reset LED and front panel display
                UIMiniFramework.Modules.FrontPanel.setLed(PluginInterface.FrontPanel.state.LED_BLINK);
                UIMiniFramework.Modules.FrontPanel.display(' ', true);

                // FTI
                if (false || parseInt(PluginInterface.Setup.getFtiCompleted(), 10) === 0) {
                    UIMiniFramework.Modules.Confirmations.removeByCode('wantToFormatCode');
                    UIMiniFramework.Modules.Input.lockInput(false);
                    if (!UIMiniFramework.Globals.isPredefinedServiceListCreated) {
                        UIMiniFramework.Globals.isPredefinedServiceListCreated = true;
                        PluginInterface.ServiceZapper.fCreatePredefinedServiceList();
                    }
                    // do not open fti screens if already opened neither close it in standby mode
                    if (!UIMiniFramework.Modules.Settings.isCreated) {
                        UIMiniFramework.Modules.Settings.create(UIMiniFramework.Globals.modules.settings.ftiWelcome, UIMiniFramework.Modules.Settings.modes.fti);
                        UIMiniFramework.Modules.Settings.show();
                    }
                }
                else {
                    UIMiniFramework.Globals.isWakeUpFromStandby = true;
                    // show loader on booting till the zap is processed
                    UIMiniFramework.Modules.Loader.toggleLoader(true, 0, null, null, null, null, false);
                    console.log('RESTORE PREDEFINED LIST');
                    PluginInterface.ServiceZapper.fRestorePredefinedServiceList(0);
                }

                //get value for ethernet cable connect status
                UIMiniFramework.Globals.isNetworkConnected = PluginInterface.MediaBrowsing.fGetEthStatus();

                //set network for ssu
                var data = PluginInterface.Network.fGetNetSettings().split('|');
                PluginInterface.Setup.fSsuSetIpConfig(data[0] == "dhcp", data[1], data[2], data[3], data[4], data[5]);

                //restart hbbtv when get from standby state
                if (UIMiniFramework.Config.MODULES.Hbbtv) {
                    UIMiniFramework.Modules.Hbbtv.restart(false);
                }
                // Reset Sleep Timer when exiting from standby
                PluginInterface.Setup.fSetSleepTimer(PluginInterface.Setup.eSleepTimer.SLEEP_TIMER_OFF);
                // check muted state and display volume bar if muted
                UIMiniFramework.Modules.VolumeBar.checkInitialState();
                break;
            case PluginInterface.Setup.eSmEvents.TRANSITION_STANDBY: //1
                UIMiniFramework.Globals.isStandby = true;
                UIMiniFramework.Modules.Hbbtv.hide();
                UIMiniFramework.Tools.toggleStandbyOverlay(true);
                PluginInterface.Cak.fSetCallbacks(null, null);
                PluginInterface.ChannelInstallation.fSetCallbacks(null, null);
                PluginInterface.Epg.fSetCallbacks(null, null);
                PluginInterface.Hbbtv.fSetCallbacks(null);
                /* Set device notification callback in order to recognize device mount state change in stand by mode */
                PluginInterface.MediaBrowsing.fSetCallbacks(null, null, null, ui.App.Callbacks.deviceNotification.bind(ui.App.Callbacks), null, null, null);
                PluginInterface.MediaPlayback.fSetCallbacks(null);
                PluginInterface.ParentalControl.fSetCallbacks(null, null);
                PluginInterface.Pvr.fSetCallbacks(null, null, ui.App.Callbacks.pvrCallback.bind(ui.App.Callbacks), null, null);
                PluginInterface.Reminder.fSetCallbacks(null);
                PluginInterface.ServiceZapper.fSetCallbacks(null, null, null, null, null, null, null);
                PluginInterface.Setup.fSetCallbacks(null, null, null);
                PluginInterface.SignalStatus.fSetCallbacks(null);
                PluginInterface.StreamComponents.fSetCallbacks(null, null, null);
                // do not call exit key handler if in fti
                if (parseInt(PluginInterface.Setup.getFtiCompleted(), 10) === 1) {
                    UIMiniFramework.Modules.Input.triggerKeyHandler(UIMiniFramework.Keys.Exit, UIMiniFramework.Globals.keySource.RCU, true);
                    // display loader when entering standby so it's displayed when exiting from standby, will be closed when zap is finished
                    setTimeout(function () {
                        UIMiniFramework.Modules.Loader.toggleLoader(true, 0, null, null, null, null, false);
                    }, 120);
                }
                setTimeout(function () {
                    UIMiniFramework.Modules.FrontPanel.display(' ');
                    UIMiniFramework.Modules.Input.lockInput(true);
                }, 150);
                UIMiniFramework.Modules.FrontPanel.setLed(PluginInterface.FrontPanel.state.LED_OFF);
                // remove volume bar from screen
                UIMiniFramework.Modules.VolumeBar.destroy();
                break;
            default:
                break;
        }
    },

    init: function () {
        if (UIMiniFramework.Globals.gPCTest) {
            UIMiniFramework.Globals.service.isZapped = true;
            $('html').css('background-color', '#000000');
            setTimeout(function () {
                UIMiniFramework.Modules.Loader.toggleLoader(false);
            }, 1000);
            UIMiniFramework.Modules.DummyVideoController.init();
            UIMiniFramework.Modules.Legend.create();
            UIMiniFramework.Modules.Legend.show();
        }
        else {
            $('#liveVideo').remove();
        }
        PluginInterface.Setup.fInitSTB(
            ui.App.Init.standbyCallback.bind(ui.App.Init)
        );
        // initialize modules
        PluginInterface.ServiceZapper.fInitServiceZapper();
        PluginInterface.SignalStatus.fInitSignalStatus();
        PluginInterface.MediaBrowsing.fInitMedia();
        PluginInterface.Reminder.fInitReminder();
        PluginInterface.MediaPlayback.fInitMediaPlayback();
        PluginInterface.Epg.fInitEpg();
        PluginInterface.Pvr.fInitPvr();
        PluginInterface.Hbbtv.fInitHbbtv();
        PluginInterface.Network.fInitNetwork();
        PluginInterface.FrontPanel.fInitFrontPanel(UIMiniFramework.Modules.FrontPanel.fpKeyPressCallback.bind(UIMiniFramework.Modules.FrontPanel));
        PluginInterface.AVSettings.fInitAVSettings();
        PluginInterface.Cak.fInitCak();
        PluginInterface.ChannelInstallation.fInitChannelScan();
        PluginInterface.ParentalControl.fInitParentalControl();

        // set config params
        PluginInterface.Mappings.Globals.gSignalType = PluginInterface.Setup.fGetSignalType();
        UIMiniFramework.Globals.signalType = UIMiniFramework.Tools.getQueryParam("signalType") ? parseInt(UIMiniFramework.Tools.getQueryParam("signalType"), 10) : PluginInterface.Setup.fGetSignalType();
        UIMiniFramework.Globals.platform = UIMiniFramework.Tools.getQueryParam("platform") ? UIMiniFramework.Tools.getQueryParam("platform") : PluginInterface.Setup.fGetBoardName();
        // init translation file
        UIMiniFramework.TranslationManager.init();
        //loading language
        UIMiniFramework.Globals.languages = new UIMiniFramework.Languages();
        UIMiniFramework.Globals.language = PluginInterface.Setup.getOsdLanguage();
        if (!UIMiniFramework.Tools.isValueInObject(UIMiniFramework.Globals.languages.items, UIMiniFramework.Globals.language)) {
            UIMiniFramework.Globals.language = UIMiniFramework.Globals.languages.default;
        }
        // init pvr data; pvr padding, isPvrEnabled ...
        if (UIMiniFramework.Config.MODULES.Pvr) {
            UIMiniFramework.Modules.Pvr.init();
        }
        // osd timeout
        UIMiniFramework.Globals.osdTimeout = PluginInterface.Setup.getOsdTimeout() * 1000;
        //Set active service list
        PluginInterface.ServiceZapper.fSetActiveServiceList(PluginInterface.ServiceZapper.getLastActiveServiceList());
        // set hbbtv on/off according to global user settings
        PluginInterface.Hbbtv.fSetHbbtvOnOff(PluginInterface.Hbbtv.fGetHbbtvOnOff());
        // set HDCP
        PluginInterface.AVSettings.fSetHdcp(PluginInterface.AVSettings.fGetHdcp());
        // set video on demand
        PluginInterface.Vod.fInitVideoOnDemand();
        // load custom css
        UIMiniFramework.Tools.loadCustomCSS(UIMiniFramework.Globals.platform);
    }
};