"use strict";

ui.Mappings.CustomConfirmations = {
    toggleExternalComponents: function (isCreated) {
        UIMiniFramework.Modules.PermanentInformations.togglePermanentInfo();
        if (UIMiniFramework.Config.MODULES.Info) {
            UIMiniFramework.Modules.Info.toggle(!isCreated);
        }
        if (UIMiniFramework.Config.MODULES.LanguageSubtitle) {
            UIMiniFramework.Modules.LanguageSubtitle.toggleSubtitle();
        }
        if (UIMiniFramework.Config.MODULES.TvGuide){
            UIMiniFramework.Modules.TvGuideFilters.toggle(!isCreated);
        }
        if (UIMiniFramework.Config.MODULES.MultimediaDescription) {
            UIMiniFramework.Modules.MultimediaDescription.toggle(!isCreated);
        }
        if (UIMiniFramework.Config.MODULES.Scheduler) {
            UIMiniFramework.Modules.CustomSchedule.toggle(!isCreated);
        }
        if (UIMiniFramework.Config.MODULES.enterPin) {
            UIMiniFramework.Modules.Settings.screens.enterPin.toggle(!isCreated);
        }
        if (UIMiniFramework.Config.MODULES.satelliteScan) {
            UIMiniFramework.Modules.Settings.screens.satelliteScan.setupSatellite.toggle(!isCreated);
        }

    },

    dummyCustomConfirmation: {
        create: function () {
        },
        destroy: function () {
        },
        handleKeyPress: function () {
        }
    },

    serviceListUpdatedInStandby: {
        create: function (messageCode) {
            var content = '';
            var newServices = [];
            var newServicesTv = UIMiniFramework.ServiceListCache.serviceList[PluginInterface.ServiceZapper.serviceList.TV_LIST].filter(function (element, index, array) {
                return element.bNewServiceFlag == 1;
            });
            var newServicesRadio = UIMiniFramework.ServiceListCache.serviceList[PluginInterface.ServiceZapper.serviceList.RADIO_LIST].filter(function (element, index, array) {
                return element.bNewServiceFlag == 1;
            });
            newServices = newServicesTv.concat(newServicesRadio);
            for (var i in newServices) {
                var item = newServices[i];
                content += '<div class="item"><div class="itemLcn">' + item.lcn + '</div><div class="itemName">' + item.name + '</div></div>';
            }
            $('.confirmation.' + messageCode + ' .messageContent').html(content);
        },

        destroy: function (messageCode) {
            // show channel list editor with new found services marked for editing
            UIMiniFramework.Modules.Settings.create(UIMiniFramework.Globals.modules.settings.channelListEditor);
            UIMiniFramework.Modules.Settings.show();
        },

        scrollText: function (direction) {
            var elem = $('.confirmation.serviceListUpdatedInStandby .messageContent');
            elem.scrollTop(elem.scrollTop() + (direction * 31));
        },

        keyPressed: function () {
            UIMiniFramework.Modules.Confirmations.removeByCode('serviceListUpdatedInStandby');
        },

        handleKeyPress: function (keyCode) {
            switch (keyCode) {
                case UIMiniFramework.Keys.Up:
                    this.scrollText(-1);
                    return true;
                case UIMiniFramework.Keys.Down:
                    this.scrollText(1);
                    return true;
                default:
                    this.keyPressed();
                    return true;
            }
        }
    },

    replacedSDWithHDservice: {
        create: function (messageCode) {
            var content = '';
            var newServices = [];
            var newServicesTv = UIMiniFramework.ServiceListCache.serviceList[PluginInterface.ServiceZapper.serviceList.TV_LIST].filter(function (element, index, array) {
                return element.isSDReplacedWithHD == 1;
            });
            var newServicesRadio = UIMiniFramework.ServiceListCache.serviceList[PluginInterface.ServiceZapper.serviceList.RADIO_LIST].filter(function (element, index, array) {
                return element.isSDReplacedWithHD == 1;
            });
            newServices = newServicesTv.concat(newServicesRadio);
            for (var i in newServices) {
                var item = newServices[i];
                content += '<div class="item"><div class="itemLcn">' + item.lcn + ' ' + '</div><div class="itemName">' + item.name + '</div></div>';
            }
            $('.confirmation.' + messageCode + ' .messageContent').html(content);
        },

        destroy: function (messageCode) {
            UIMiniFramework.Modules.Settings.show();
        },

        scrollText: function (direction) {
            var elem = $('.confirmation.replacedSDWithHDservice .messageContent');
            elem.scrollTop(elem.scrollTop() + (direction * 31));
        },

        keyPressed: function () {
            UIMiniFramework.Modules.Confirmations.removeByCode('replacedSDWithHDservice');
        },

        handleKeyPress: function (keyCode) {
            switch (keyCode) {
                case UIMiniFramework.Keys.Up:
                    this.scrollText(-1);
                    return true;
                case UIMiniFramework.Keys.Down:
                    this.scrollText(1);
                    return true;
                default:
                    this.keyPressed();
                    return true;
            }
        }
    },

    replacedSdOrHDWithUHDService: {
        create: function (messageCode) {
            var content = '';
            var newServices = [];
            var newServicesTv = UIMiniFramework.ServiceListCache.serviceList[PluginInterface.ServiceZapper.serviceList.TV_LIST].filter(function (element, index, array) {
                return element.isSDOrHDReplacedWithUHD == 1;
            });
            var newServicesRadio = UIMiniFramework.ServiceListCache.serviceList[PluginInterface.ServiceZapper.serviceList.RADIO_LIST].filter(function (element, index, array) {
                return element.isSDOrHDReplacedWithUHD == 1;
            });
            newServices = newServicesTv.concat(newServicesRadio);
            for (var i in newServices) {
                var item = newServices[i];
                content += '<div class="item"><div class="itemLcn">' + item.lcn + ' ' + '</div><div class="itemName">' + item.name + '</div></div>';
            }
            $('.confirmation.' + messageCode + ' .messageContent').html(content);
            //UIMiniFramework.Modules.Confirmations.removeByCode('replacedSdOrHDWithUHDService');
        },

        destroy: function (messageCode) {
            UIMiniFramework.Modules.Settings.show();
        },

        scrollText: function (direction) {
            var elem = $('.confirmation.replacedSdOrHDWithUHDService .messageContent');
            elem.scrollTop(elem.scrollTop() + (direction * 31));
        },

        keyPressed: function () {
            UIMiniFramework.Modules.Confirmations.removeByCode('replacedSdOrHDWithUHDService');
        },

        handleKeyPress: function (keyCode) {
            switch (keyCode) {
                case UIMiniFramework.Keys.Up:
                    this.scrollText(-1);
                    return true;
                case UIMiniFramework.Keys.Down:
                    this.scrollText(1);
                    return true;
                default:
                    this.keyPressed();
                    return true;
            }
        }
    },

    // removed on any key press
    standbyApd: {
        timerId: null,
        timerCount: 60,

        create: function (messageCode) {
            $('.confirmation.' + messageCode + ' .apdTimer').text(--ui.Mappings.CustomConfirmations.standbyApd.timerCount + ' ' + UIMiniFramework.Translations.seconds[UIMiniFramework.Globals.language]);
            clearTimeout(this.timerId);
            this.timerId = setInterval(function () {
                $('.confirmation.' + messageCode + ' .apdTimer').text(--ui.Mappings.CustomConfirmations.standbyApd.timerCount + ' ' + UIMiniFramework.Translations.seconds[UIMiniFramework.Globals.language]);
                if (ui.Mappings.CustomConfirmations.standbyApd.timerCount == 0) {
                    clearInterval(ui.Mappings.CustomConfirmations.standbyApd.timerId);
                    UIMiniFramework.Modules.Confirmations.removeByCode('standbyApd');
                }
            }, 1000);
        },

        destroy: function (messageCode) {
            clearInterval(this.timerId);
            this.timerCount = 60;
        },

        keyPressed: function () {
            UIMiniFramework.Modules.Confirmations.removeByCode('standbyApd');
        },

        handleKeyPress: function (keyCode) {
            switch (keyCode) {
                default:
                    this.keyPressed();
                    return true;
            }
        }
    },

    pvrActivationCode: {
        keyPressCount: 0,

        create: function () {
            this.keyPressCount = 0;
        },

        destroy: function () {
        },

        handleKeyPress: function (keyCode) {
            this.keyPressCount++;
            switch (keyCode) {
                case UIMiniFramework.Keys.TvRadio:
                    UIMiniFramework.Modules.Pvr.pvrActivationSequenceCount = 1;
                    break;
                case UIMiniFramework.Keys.Record:
                    if (UIMiniFramework.Modules.Pvr.pvrActivationSequenceCount === 1) {
                        UIMiniFramework.Modules.Pvr.pvrActivationSequenceCount = 2;
                        break;
                    }
                case UIMiniFramework.Keys.PlayPause:
                    if (UIMiniFramework.Modules.Pvr.pvrActivationSequenceCount === 2) {
                        UIMiniFramework.Modules.Pvr.pvrActivationSequenceCount = 3;
                        break;
                    }
                case UIMiniFramework.Keys.OK:
                    if (UIMiniFramework.Modules.Pvr.pvrActivationSequenceCount === 3) {
                        UIMiniFramework.Modules.Pvr.pvrActivationSequenceCount = 0;
                        UIMiniFramework.Modules.Confirmations.confirmationMessageCodes.pvrActivationCode = null;
                        PluginInterface.Setup.setPvrActivated(1);
                        UIMiniFramework.Modules.Confirmations.confirm();
                        return true;
                    }
            }

            if (this.keyPressCount == 4) {
                $('.pvrActivationProgress div:nth-child(' + this.keyPressCount + ')').addClass('filled');
                UIMiniFramework.Modules.Pvr.pvrActivationSequenceCount = 0;
                this.keyPressCount = 0;
                setTimeout(function () {
                    $('.pvrActivationProgress div').removeClass('filled');
                }, 200);
            }
            else {
                $('.pvrActivationProgress div:nth-child(' + this.keyPressCount + ')').addClass('filled');
            }
        }
    },

    // removed on any key press
    formatCode: {
        timerId: null,
        timerCount: 0,

        create: function (messageCode) {
            var progress = $('<div class="formatProgressWrapper"><div class="formatProgress"></div></div>');
            $('.confirmation.' + messageCode + ' .body').append(progress);

            clearTimeout(this.timerId);
            this.timerId = setInterval(function () {
                ui.Mappings.CustomConfirmations.formatCode.timerCount++;
                var width = 10 * 2 * Math.log(ui.Mappings.CustomConfirmations.formatCode.timerCount);
                $('.confirmation.' + messageCode + ' .formatProgress').css('width', width + '%');
            }, 1000);
        },

        destroy: function (messageCode) {
            clearInterval(this.timerId);
            this.timerCount = 0;
        },

        keyPressed: function () {
        },

        handleKeyPress: function (keyCode) {
            switch (keyCode) {
                default:
                    this.keyPressed();
                    return true;
            }
        }
    },

    ignoreExit: {
        create: function (messageCode) {
        },

        destroy: function (messageCode) {
        },

        keyPressed: function () {
        },

        handleKeyPress: function (keyCode) {
            switch (keyCode) {
                case UIMiniFramework.Keys.Exit:
                case UIMiniFramework.Keys.Back:
                    return true;

                default:
                    return false;
            }
        }
    }
};