"use strict";

ui.Mappings.EpgChangeFilters = function(context){
    UIMiniFramework.CustomComponents.Context.call(this, context);

    var channelLists = new ui.Mappings.ChannelLists().horizontalItems;
    var channelListsItems = [];
    var channelListsKeys = [];
    _.forEach(channelLists, function(item, key) {
        channelListsItems.push(item.label);
        channelListsKeys.push(item.index);
    }, this);

    this.template = UIMiniFramework.Templates.tvGuide.changeFilters;
    this.items = [
        new UIMiniFramework.CustomComponents.Spinner(
            'channelLists',
            UIMiniFramework.Translations.channelList[UIMiniFramework.Globals.language],
            channelListsItems,
            channelListsKeys,
            PluginInterface.ServiceZapper.serviceList.TV_LIST,
            function(param){}
        ),
        new UIMiniFramework.CustomComponents.Spinner(
            'genres',
            UIMiniFramework.Translations.genres[UIMiniFramework.Globals.language],
            [
                'Genre 1',
                'Genre 2',
                'Genre 3'
            ],
            [0, 1, 2],
            0,
            function(param){}
        ),
        new UIMiniFramework.CustomComponents.Button(
            '',
            {
                OK: {
                    visible: true,
                    enabled: true,
                    label: UIMiniFramework.Translations.toSave[UIMiniFramework.Globals.language]
                },
                BACK: {
                    visible: true,
                    enabled: true,
                    label: UIMiniFramework.Translations.toGoBack[UIMiniFramework.Globals.language]
                }
            }
        ),
        new UIMiniFramework.CustomComponents.Label(
            'title',
            UIMiniFramework.Translations.find[UIMiniFramework.Globals.language],
            ''
        )
    ]
};

UIMiniFramework.Tools.inheritPrototype(ui.Mappings.EpgChangeFilters, UIMiniFramework.CustomComponents.Context);