"use strict";

ui.Mappings.PinEntryItems = function(context){
    UIMiniFramework.CustomComponents.Context.call(this, context);

    var validatePin = function(){
        var pinCode = this.getValue();
        var result = false;
        var data = PluginInterface.ServiceZapper.fGetServiceData(UIMiniFramework.Globals.service.activeServiceList, UIMiniFramework.Globals.service.channelIndex);
        switch (context.lockType) {
            case PluginInterface.ParentalControl.eLockType.CHANNEL:
                result = UIMiniFramework.Tools.isStbPinCodeValid(pinCode, PluginInterface.ParentalControl.ePinSource.POPUP, data.index);
                if (result) {
                    UIMiniFramework.Globals.service.isServiceLocked = false;
                }
                break;
            case PluginInterface.ParentalControl.eLockType.AGE:
                result = UIMiniFramework.Tools.isScPinCodeValid(pinCode);
                if (result) {
                    UIMiniFramework.Globals.service.isServiceAgeLocked = false;
                }
                break;
            case PluginInterface.ParentalControl.eLockType.PVR:
                result = UIMiniFramework.Tools.isStbPinCodeValid(pinCode, PluginInterface.ParentalControl.ePinSource.POPUP, data.index);
                break;
            case PluginInterface.ParentalControl.eLockType.PVR_AGE:
                result = UIMiniFramework.Tools.isScPinCodeValid(pinCode);
                /* result will be obtained through cakScPinCallback */
                result = false;
                /* Remove pin entry popup */
                context.destroy(context.lockType);
                UIMiniFramework.Tools.toggleLockedOverlay(false);
                UIMiniFramework.Modules.Hbbtv.show();
                break;
        }

        if (result) {
            context.destroy(context.lockType);
            UIMiniFramework.Tools.toggleLockedOverlay(false);
            UIMiniFramework.Modules.Hbbtv.show();
            if (context.pinSuccessCallback) {
                context.pinSuccessCallback();
            }
        }
        else {
            this.resetPins();
        }
    };

    this.template = UIMiniFramework.Templates.genericScreen;
    this.selectedComponentIndex = 1;
    this.items = [
        new UIMiniFramework.CustomComponents.Label(
            'title',
            '',
            UIMiniFramework.Modules.PinEntry.title
        ),
        new UIMiniFramework.CustomComponents.Password(
            'pin',
            '',
            function(param){},
            true,
            true,
            4,
            validatePin
        )
    ]
};

UIMiniFramework.Tools.inheritPrototype(ui.Mappings.PinEntryItems, UIMiniFramework.CustomComponents.Context);