"use strict";

UIMiniFramework.CustomComponents.permanentInformationItem = function(data, replacableData, isTopPriority, isClosable, messageCode, title){
    this.data = data || '';
    this.title = (typeof title == 'undefined' || title == null) ? UIMiniFramework.Translations.information[UIMiniFramework.Globals.language] : title;
    this.messageCode = (typeof messageCode == 'undefined' || !messageCode) ? null : messageCode;
    this.replacableData = replacableData || null;
    this.isTopPriority = isTopPriority || false;
    this.isClosable = isClosable || true;
    this.code = 'PI' + new Date().getTime() + Math.floor(Math.random() * 1000000);
};

UIMiniFramework.CustomComponents.permanentInformationItem.isTopPriorityActive = false;
UIMiniFramework.CustomComponents.permanentInformationItem.count = 0;
UIMiniFramework.CustomComponents.permanentInformationItem.prototype.initialTop = 90;
UIMiniFramework.CustomComponents.permanentInformationItem.prototype.initialRight = 80;
UIMiniFramework.CustomComponents.permanentInformationItem.prototype.positionShift = 0;

UIMiniFramework.CustomComponents.permanentInformationItem.prototype.init = function(){
    this.start();
    UIMiniFramework.Modules.PermanentInformations.updated(UIMiniFramework.Modules.PermanentInformations.updateStatus.initialized);
};

UIMiniFramework.CustomComponents.permanentInformationItem.prototype.start = function(){
    if (this.isTopPriority) {
        UIMiniFramework.CustomComponents.permanentInformationItem.isTopPriorityActive = true;
    }
    ++UIMiniFramework.CustomComponents.permanentInformationItem.count;
    this.render();
    UIMiniFramework.Modules.PermanentInformations.items.unshift(this);
    UIMiniFramework.Modules.PermanentInformations.updated(UIMiniFramework.Modules.PermanentInformations.updateStatus.added);
};

UIMiniFramework.CustomComponents.permanentInformationItem.prototype.stop = function(){
    if (this.isTopPriority) {
        UIMiniFramework.CustomComponents.permanentInformationItem.isTopPriorityActive = false;
    }
    var messageCode = this.messageCode;
    --UIMiniFramework.CustomComponents.permanentInformationItem.count;
    UIMiniFramework.Modules.PermanentInformations.el.find('.' + this.code).remove();
    UIMiniFramework.Modules.PermanentInformations.updated(UIMiniFramework.Modules.PermanentInformations.updateStatus.removed);
    // show newest - last dialog if exist
    if (UIMiniFramework.Modules.PermanentInformations.totalCount > 0) {
        UIMiniFramework.Modules.PermanentInformations.el.find('.permanentInformation').last().removeClass('hidden');
    }
    return messageCode;
};

UIMiniFramework.CustomComponents.permanentInformationItem.prototype.render = function() {
    //hide all previous dialogs
    UIMiniFramework.Modules.PermanentInformations.el.find('.permanentInformation').not('.topPriorityPermanentInformation').addClass('hidden');
    // parse replacable data
    if (this.replacableData){
        for (var prop in this.replacableData){
            this.data = this.data.replace(prop, this.replacableData[prop]);
        }
    }
    // parse new lines
    this.data = this.data.replace(/\r\n|\r|\n/g, "<br>")
    var item = $(UIMiniFramework.Templates.permanentInformations.informationItem);
    item.children('.header').text(this.title);
    item.children('.body').html(this.data);
    item.addClass(this.messageCode);
    item.addClass(this.code);
    item.toggleClass('topPriorityPermanentInformation', this.isTopPriority);
    if (UIMiniFramework.CustomComponents.permanentInformationItem.isTopPriorityActive && !this.isTopPriority){
        item.addClass('hidden');
    }
    item.css({
        'top': (this.initialTop + (UIMiniFramework.CustomComponents.permanentInformationItem.count - 1) * this.positionShift) + 'px',
        'right': (this.initialRight + (UIMiniFramework.CustomComponents.permanentInformationItem.count - 1) * this.positionShift) + 'px'
    });
    UIMiniFramework.Modules.PermanentInformations.el.append(item);
};