"use strict";

UIMiniFramework.Config = {
    // DOM selector for UI application
    uiAppWrapperSelector: '#app',
    bodySelector: '#body',
    // enable or disable dummy video controller playback
    isDummyVideoControllerEnabled: true,
    // 10 minutes,
    smartCardPinBlockedSeconds: 600,
    // minimum recording bufer size in Mb
    recordingMinimumBufferSizeInMb: 512,

    init: function(){
        this.MODULES = {
            ChannelList:                true && typeof UIMiniFramework.Modules.ChannelList != 'undefined',
            Clock:                      true && typeof UIMiniFramework.Modules.Clock != 'undefined',
            Confirmations:              true && typeof UIMiniFramework.Modules.Confirmations != 'undefined',
            DMR:                        true && typeof UIMiniFramework.Modules.DMR != 'undefined',
            DummyVideoController:       true && typeof UIMiniFramework.Modules.DummyVideoController != 'undefined',
            FrontPanel:                 true && typeof UIMiniFramework.Modules.FrontPanel != 'undefined',
            Hbbtv:                      true && typeof UIMiniFramework.Modules.Hbbtv != 'undefined',
            ImagePlayer:                true && typeof UIMiniFramework.Modules.ImagePlayer != 'undefined',
            Info:                       true && typeof UIMiniFramework.Modules.Info != 'undefined',
            InfoBanner:                 true && typeof UIMiniFramework.Modules.InfoBanner != 'undefined',
            Input:                      true && typeof UIMiniFramework.Modules.Input != 'undefined',
            LanguageSubtitle:           true && typeof UIMiniFramework.Modules.LanguageSubtitle != 'undefined',
            Loader:                     true && typeof UIMiniFramework.Modules.Loader != 'undefined',
            MediaPlayer:                true && typeof UIMiniFramework.Modules.MediaPlayer != 'undefined',
            Menu:                       true && typeof UIMiniFramework.Modules.Menu != 'undefined',
            Multimedia:                 true && typeof UIMiniFramework.Modules.Multimedia != 'undefined',
            Notifications:              true && typeof UIMiniFramework.Modules.Notifications != 'undefined',
            PermanentInformations:      true && typeof UIMiniFramework.Modules.PermanentInformations != 'undefined',
            PinEntry:                   true && typeof UIMiniFramework.Modules.PinEntry != 'undefined',
            Pvr:                        true && typeof UIMiniFramework.Modules.Pvr != 'undefined',
            RadioPlayingOverlay:        true && typeof UIMiniFramework.Modules.RadioPlayingOverlay != 'undefined',
            RecordedTv:                 true && typeof UIMiniFramework.Modules.RecordedTv != 'undefined',
            Scheduler:                  true && typeof UIMiniFramework.Modules.Scheduler != 'undefined',
            Teletext:                   true && typeof UIMiniFramework.Modules.Teletext != 'undefined',
            Timeshift:                  true && typeof UIMiniFramework.Modules.Timeshift != 'undefined',
            TvGuide:                    true && typeof UIMiniFramework.Modules.TvGuide != 'undefined',
            Keyboard:                   true && typeof UIMiniFramework.Modules.Keyboard != 'undefined',
            VolumeBar:                  true && typeof UIMiniFramework.Modules.VolumeBar != 'undefined',
            ZapperWrapper:              true && typeof UIMiniFramework.Modules.ZapperWrapper != 'undefined',
            Legend:                     true && typeof UIMiniFramework.Modules.Legend != 'undefined',

            settings:                   true && (typeof UIMiniFramework.Modules.Settings != 'undefined'),
            administration:             true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.administration != 'undefined'),
            audioSettings:              true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.audioSettings != 'undefined'),
            backUp:                     true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.backUp != 'undefined'),
            caInformation:              true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.caInformation != 'undefined'),
            channelListEditor:          true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.channelListEditor != 'undefined'),
            channelScan:                true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.channelScan != 'undefined'),
            enterPin:                   true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.enterPin != 'undefined'),
            ethernetSettings:           true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.ethernetSettings != 'undefined'),
            factoryDefault:             true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.factoryDefault != 'undefined'),
            ftiChooseConfiguration:     true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.ftiChooseConfiguration != 'undefined'),
            languageSettings:           true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.languageSettings != 'undefined'),
            manualScan:                 true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.manualScan != 'undefined'),
            mediaInformation:           true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.mediaInformation != 'undefined'),
            motorSetup:                 true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.motorSetup != 'undefined'),
            multiUnicableSetup:         true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.multiUnicableSetup != 'undefined'),
            parentalControl:            true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.parentalControl != 'undefined'),
            pvrPadding:                 true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.pvrPadding != 'undefined'),
            restoreAll:                 true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.restoreAll != 'undefined'),
            satelliteScan:              true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.satelliteScan != 'undefined'),
            singleUnicableSetup:        true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.singleUnicableSetup != 'undefined'),
            smartcardPinChange:         true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.smartcardPinChange != 'undefined'),
            stbPinChange:               true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.stbPinChange != 'undefined'),
            swUpgradeViaSatellite:      true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.swUpgradeViaSatellite != 'undefined'),
            swUpgradeViaUsb:            true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.swUpgradeViaUsb != 'undefined'),
            updateChangeChannelList:    true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.updateChangeChannelList != 'undefined'),
            version:                    true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.version != 'undefined'),
            videoSettings:              true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.videoSettings != 'undefined'),
            wifiSettings:               true && (typeof UIMiniFramework.Modules.Settings != 'undefined' && typeof UIMiniFramework.Modules.Settings.screens.wifiSettings != 'undefined')
        }
    }
};