'use strict';

UIMiniFramework.Modules.RadioPlayingOverlay = {
    GUID: UIMiniFramework.Tools.getGUID(),
    el: null,
    wrapperSelector: UIMiniFramework.Config.bodySelector,
    isCreated: false,
    isShown: false,
    components: [],
    lockedOverlayTimeoutId: null,

    create: function (serviceName) {
        if (!this.isCreated) {
            this.init(serviceName);
            this.render();
            this.hide();
            this.addToDOM();
            this.updateLabels();
            this.isCreated = true;
            this.isShown = false;
        }
    },

    destroy: function () {
        if (this.isCreated) {
            this.removeFromDOM();
            try {
                this.components.destroy();
            }
            catch (error) {
            }
            finally {
                this.components = [];
            }
            this.isCreated = false;
            this.isShown = false;
        }
    },

    init: function(serviceName){
        this.components = new ui.Mappings.RadioPlayingOverlayItems(this, serviceName);
    },

    render: function () {
        this.el = $(this.components.template);
        this.el.addClass('radioPlayingOverlay');
        if (this.components && this.components.renderComponents) {
            this.components.renderComponents();
        }
    },

    updateLabels: function () {
        if (this.components && this.components.updateComponentLabels) {
            this.components.updateComponentLabels();
        }
    },

    addToDOM: function () {
        $(this.wrapperSelector).append(this.el);
    },

    removeFromDOM: function () {
        this.el.remove();
        this.el = null;
    },

    show: function () {
        if (this.isCreated && !this.isShown) {
            this.el.removeClass('invisible');
            this.isShown = true;
        }
    },

    hide: function () {
        if (this.isCreated) {
            this.el.addClass('invisible');
            this.isShown = false;
        }
    }
};